#include "WordDraw.h"
#include "Word.h"
#include "DehornoyForm.h"
#include <iostream>
#include "BraidGroup.h"
#include "ThRightNormalForm.h"
#include "FRDFIT.h"
#include "ShortBraidForm.h"


struct WordBreak
{
  Word w1;
  Word w2;
  Word b1;
  Word b2;
};


WordBreak breakBraidWord( int N,const Word& w, int row_break, int L_col_break, int U_col_break)
{
  WordBreak wb;
  vector<int> positions(N+2,-1); // +2 for the left and right padding
  int theLength = 0;


  int i=0;
  for (ConstWordIterator wI=w.begin();wI!=w.end();wI++,i++){
    Generator g = *wI;
    int absg = abs(g);
    int pos = max(positions[absg],max(positions[absg-1],positions[absg+1])) + 1;

    //    cout << pos << " " << L_col_break <<  endl;
    if ( pos+1 < L_col_break )
      wb.w1.push_back(g);
    else if ( pos+1 > U_col_break )
      wb.w2.push_back(g);
    else {
      //      cout << g << " " << row_break <<  endl;
      if ( absg < row_break )
	wb.b1.push_back(g);
      else if ( absg> row_break )
	wb.b2.push_back(g);
      else {
	cout << "Error: cannot have generators on a row break." << g << " " << pos << endl;
	exit(0);
      }
    }
    positions[absg] = pos;
    if (theLength < pos) theLength = pos;
  }
  return wb;
}

int main()
{
  int lw = 20;
  int lx = 600;

  int l = 500;
  int N = 20;

  for (int i=0;i<1;i++) {
    
    Word w = Word::randomWord( N-1, l );
    
    
    
    //    Word sbf = shortBraidForm( N, w );
    Word sbf = shortenBraid(  N ,  w );
    
    
    list<Word> words;
    words.push_back(sbf);
    //    words.push_back(sw);
      
    WordDraw sbfd(N-1,words);
    sbfd.saveTo( string("word.ppm") );  

    while (1){
    int row_break,L_col_break,U_col_break;
    cout << "Enter rb , l_cb, U_cb : " << flush;
    //scanf(" %d %d %d",row_break, L_col_break, U_col_break); 
    cin >> row_break; cin >> L_col_break; cin >> U_col_break;
    cout << row_break << " " << L_col_break << " " <<  U_col_break << endl;
    WordBreak wb =  breakBraidWord( N,sbf,row_break,L_col_break,U_col_break );
    Word pw = shortenBraid(N,wb.w1*wb.b1*wb.b2*wb.w2);
    Word pw1 = shortenBraid(N,wb.w1*wb.b2*wb.b1*wb.w2);
    Word pw2 = shortenBraid(N,wb.w1*shortenBraid(N,wb.b2)*shortenBraid(N,wb.b1)*wb.w2);
    Word pw3 = shortenBraid(N,wb.w1*shortenBraid(N,wb.b2)*shortenBraid(N,wb.b1)*wb.w2);
    Word pw4 = shortenBraid(N,shortenBraid(N,wb.w1)*shortenBraid(N,wb.b2)*
			    shortenBraid(N,wb.b1)*shortenBraid(N,wb.w2));

    cout << "WB L : " <<  endl 
	 << wb.w1 << " " << wb.w1.length() << endl
	 << wb.b1 << " " << wb.b1.length() << endl 
	 << wb.b2 << " " << wb.b2.length() << endl
	 << wb.w2 << " " << wb.w2.length() << endl;
    cout << pw.length() << " " << sbf.length() << endl;
    cout << pw1.length() << " " << sbf.length() << endl;    
    cout << pw2.length() << " " << sbf.length() << endl;
    cout << pw3.length() << " " << sbf.length() << endl;
    cout << pw4.length() << " " << sbf.length() << endl;
    /*    list<Word> bwords;
	  words.push_back(wb.w1);
	  words.push_back(wb.b1);
	  words.push_back(wb.b2);
	  words.push_back(wb.w2);
	  
	  WordDraw bd(N-1,bwords);
	  bd.saveTo( string("bword.ppm") );  
    */

    BraidGroup G( N );
    ThRightNormalForm gnf( G , sbf*-pw );
    if( !gnf.isTrivial() ) {
      cout << "FALSE" << endl;
      exit(0);
    }
    }
   }
  
  
  return 0;
}
