
#include "time.h"
#include "Integer.h"
#include "Rational.h"

#include "map"
#include "vector"
#include "iostream"
using namespace std;


typedef pair<int , int> PII;


ostream& print( ostream& os , const map< PII , Integer >& table )
{
  map< PII , Integer >::const_iterator t_it = table.begin( );
  for( ; t_it!=table.end( ) ; ++t_it )
    os << "(" << (*t_it).first.first << "," << (*t_it).first.second << ") -> " << (*t_it).second << endl;
  return os;
}


void prob()
{
	int exp = 2100;
	int succ = 1;
	int total = 1350;

	double sum = 0;
	for( int n=0 ; n<25 ; ++n ) {
		Integer num= 1;
		Integer denom = 1;
		for( int i=1 ; i<=n ; ++i ) {
			num *= exp-i;
			denom *= i;
		}
		for( int i=0 ; i<n ; ++i )
			denom *= total;
		for( int i=0 ; i<exp-n ; ++i ) {
			num *= total-1;
			denom *= total;
		}
		
		Rational r( num , denom );
		double r1 = r;
		cout << "n = " << n << " -> " << r1 << endl;
		sum += r1;
	}
	cout << "sum = " << sum << endl;
}


int main( )
{
  srand( time(0) );

	prob( );
	return 0;

  int blocks = 300;
  int block_size = 3;
  int total_mist = 360;

  map< PII , Integer > cur_table;
  cur_table[PII(0,0)] = 1;
  print( cout , cur_table ) << endl;


  for( int i=0 ; i<blocks ; ++i ) {
    map< PII , Integer > new_table;
    map< PII , Integer >::const_iterator t_it = cur_table.begin( );
    for( ; t_it!=cur_table.end( ) ; ++t_it ) {
      int a = (*t_it).first.first;
      int b = (*t_it).first.second;
      Integer c = (*t_it).second;

      for( int s=0 ; s<=block_size && a+s<=total_mist ; ++s )
        new_table[ PII( a+s, s>=2 ? b+1 : b ) ] += c;
    }
    cur_table = new_table;
  }

	cout << endl << "===============================================" << endl;
  print( cout , cur_table ) << endl;
	cout << endl << "===============================================" << endl;

	Integer total = 0;
	map< int , Integer > no_mist_blocks;
	map< PII , Integer >::const_iterator t_it = cur_table.begin( );
  for( ; t_it!=cur_table.end( ) ; ++t_it ) {
    int a = (*t_it).first.first;
    int b = (*t_it).first.second;
    Integer c = (*t_it).second;
		no_mist_blocks[b] += c;
		total += c;
	}

	cout << "total = " << total << endl;
	map< int , Integer >::iterator n_it = no_mist_blocks.begin();
	for( ; n_it!=no_mist_blocks.end( ) ; ++n_it ) {
		int a = (*n_it).first;
		Integer b = (*n_it).second;
		Rational r( b , total );
		double rd = r;
		cout << a << " -> " << b << ", " << rd << endl;
	}

  return 0;
}